#!/usr/bin/env ruby

require 'rss/0.9'

  # Returns an RSS 0.9 feed listing all objects held
  # in the ObjectCache hash
class CacheList
  
  def initialize(  )
       
  end

    # Builds an RSS item element
  def item( obj_name )
    item = RSS::Rss::Channel::Item.new
    item.title = obj_name
    item.link = obj_name
    item.description = obj_name
    item
  end
  
    # Builds the RSS image element
  def image( title, url, link )
    image = RSS::Rss::Channel::Image.new
    image.url = url
    image.title = title
    image.link = link
    image
  end

    # The main method. Loops over the Catapult ObjectCache, creating
    # an RSS item for each object in the cache.
  def run( path )
    rss = RSS::Rss.new( "0.9" )
    chan = RSS::Rss::Channel.new
    chan.description = "Catapult object cache list"
    chan.title  = "Catapult object cache list"
    chan.link = "TODO"
    chan.language = 'en'
    chan.image = image( "TODO",  "TODO",  "TODO" )
    rss.channel = chan    
    ObjectCache.names.each do |name|
      chan.items << item( name )
    end
    rss.to_s
   end

      
  def content_type
    "text/xml"
  end
  
    # Does nothing; there are no resources to release or clean up.
  def shutdown
    STDERR.puts( "* * * * *  SHUTDOWN CacheList! * * * * * " )
  end  
end


