#!/usr/bin/env ruby

require 'rss/0.9'

  # Returns an HTML page listing all objects in the ObjectCache,
  # as well as links to tell Catapult to clear a given object from
  # the cache.
class ClearSelectedObject
  
  def initialize(  )
    @base_url = '/ClearSelectedObject/'
  end

  def link( obj_name )
     "<a href='#{@base_url}#{obj_name}'>#{obj_name}</a>"
  end
  
  def run( path )
    STDERR.puts( " RUN  #{path} " )
    path.strip!
    path.size == 0 ? list_objects : clear_object(  path.to_s )  
  end

  def clear_object( obj_name )
    STDERR.puts( " Clear objec! #{obj_name} " )
    ObjectCache.clear( obj_name.to_s.strip  )
    list_objects
  end
  
  def list_objects
    html = %{
       <html>
        <head>
        <title>Clear selected object</title>
        </head>
        <body>
        <h1>Select an object to clear</h1>
        <ul>
        !body!
        </ul>
        </body>
       </html> }
      links_list =  ""
      STDERR.puts( "Loop over cache names #{ObjectCache.names.inspect}")
    ObjectCache.names.each do  |name|
      STDERR.puts( name )      
      links_list << "<li>" + link( name ) + "</li>\n"
    end
    html.gsub( '!body!', links_list )     
  end

  
  def content_type
    "text/html"
  end
  
  def shutdown
    STDERR.puts( "* * * * *  SHUTDOWN #{__FILE__}! * * * * * " )
  end  
end


